"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var StepComponent = (function () {
    function StepComponent(changeRef) {
        this.changeRef = changeRef;
        this.viewInitFlag = false;
    }
    StepComponent.prototype.ngOnInit = function () {
        this.showKey = this.showKey || 'name';
        this.idKey = this.idKey || 'id';
        this.currentIndex = this.currentIndex || 0;
        this.findCurrentIndex();
        /*setInterval(() => {
              this.changeRef.detectChanges();
            }, 100);*/
    };
    StepComponent.prototype.findCurrentIndex = function () {
        if (this.currentData) {
            var flag = true;
            for (var i = 0; i < this.stepData.length; i++) {
                if (this.stepData[i][this.idKey] == this.currentData[this.idKey]) {
                    this.currentIndex = i;
                    flag = false;
                    break;
                }
            }
            if (flag) {
                this.currentIndex = this.stepData.length;
            }
        }
        else {
            this.currentIndex = this.stepData.length;
        }
    };
    StepComponent.prototype.calcDescWidth = function (index) {
        var boxW = this.stepBox.nativeElement.offsetWidth;
        var len = this.stepData.length;
        if (index == 0 || index == this.stepData.length - 1) {
            return (Math.floor((boxW / len) * (2 / 3)) + 'px');
        }
        else {
            return (Math.floor((boxW / len)) + 'px');
        }
    };
    StepComponent.prototype.caclDescMargin = function (index) {
        var boxW = this.stepBox.nativeElement.offsetWidth;
        var len = this.stepData.length;
        var itemW = Math.floor((boxW / len));
        if (index == 0 || index == this.stepData.length - 1) {
            return 0;
        }
        else {
            return ('-' + Math.floor(itemW / 2) + 'px');
        }
    };
    StepComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'dc-step',
                    template: "\n    <div #stepBox style=\"height: 70px;\">\n      <div *ngIf=\"stepData && stepData.length > 0\" class=\"step-ul\">\n        <ng-template ngFor let-item [ngForOf]=\"stepData\" let-i=\"index\">\n          <div class=\"step-item\"\n               [ngClass]=\"{stepDone:(i < currentIndex),stepDoing: (i == currentIndex), stepUndo: (i > currentIndex)}\">\n            {{i + 1}}\n            <span [title]=\"item[showKey]\" [style.width]=\"calcDescWidth(i)\" [style.margin-left]=\"caclDescMargin(i)\" class=\"step-desc\"\n                  [class.alignLeft]=\"i==0\" [class.alignRight]=\"i != 0 && i == stepData.length - 1\">{{item[showKey]}}</span>\n          </div>\n          <div *ngIf=\"i !== stepData.length-1\" class=\"step-line\"\n               [ngClass]=\"{stepDone:(i < currentIndex),stepDoing: (i == currentIndex), stepUndo: (i > currentIndex)}\"></div>\n        </ng-template>\n      </div>\n    </div>\n  ",
                    styles: [
                        "\n      ul, li {\n        list-style: none;\n        margin: 0;\n        padding: 0;\n      }\n\n      .step-ul {\n        display: flex;\n        flex-direction: row;\n        align-items: center;\n        font-size: 14px;\n      }\n\n      .step-item {\n        position: relative;\n        width: 30px;\n        height: 30px;\n        line-height: 27px;\n        color: #0081cc;\n        flex-shrink: 0;\n        flex-grow: 0;\n        border: 1px solid #0081cc;\n        background: #fff;\n        border-radius: 15px;\n        text-align: center;\n      }\n\n      .step-item.stepDone {\n        background: #0081cc;\n        color: #fff;\n      }\n\n      .step-item.stepDoing {\n        background: #fff;\n        color: #0081cc;\n      }\n\n      .step-item.stepUndo {\n        background: #fff;\n        border-style: dashed;\n        border-color: #c1c0c1;\n        color: #c1c0c1;\n      }\n\n      .step-line {\n        height: 1px;\n        width: 30px;\n        background-color: #ccc;\n        flex: 1;\n      }\n\n      .step-line.stepDone {\n        background-color: #0081cc;\n      }\n\n      .step-desc {\n        color: #333;\n        text-align: center;\n        position: absolute;\n        top: 35px;\n        width: 80px;\n        left: 15px;\n        margin-left: -45px;\n        text-overflow: ellipsis;\n        overflow: hidden;\n        word-wrap: normal;\n        white-space: nowrap;\n      }\n\n      .step-desc.alignLeft {\n        text-align: left;\n        margin-left: 0;\n        left: 0;\n      }\n\n      .step-desc.alignRight {\n        text-align: right;\n        right: 0;\n        left: auto;\n        margin-left: 0;\n      }\n    "
                    ],
                },] },
    ];
    /** @nocollapse */
    StepComponent.ctorParameters = function () { return [
        { type: core_1.ChangeDetectorRef, },
    ]; };
    StepComponent.propDecorators = {
        "stepBox": [{ type: core_1.ViewChild, args: ['stepBox',] },],
        "stepData": [{ type: core_1.Input },],
        "showKey": [{ type: core_1.Input },],
        "idKey": [{ type: core_1.Input },],
        "currentData": [{ type: core_1.Input },],
    };
    return StepComponent;
}());
exports.StepComponent = StepComponent;
//# sourceMappingURL=step.component.js.map